package ink.wgink.module.attn.dao.signin;

import ink.wgink.exceptions.RemoveException;
import ink.wgink.exceptions.SaveException;
import ink.wgink.exceptions.SearchException;
import ink.wgink.exceptions.UpdateException;
import ink.wgink.module.attn.pojo.bos.signin.SignInBO;
import ink.wgink.module.attn.pojo.dtos.signin.SignInDTO;
import ink.wgink.module.attn.pojo.pos.signin.SignInPO;
import org.springframework.stereotype.Repository;

import java.util.List;
import java.util.Map;

/**
 * @ClassName: ISignInDao
 * @Description: 考勤签到
 * @Author: CodeFactory
 * @Date: 2022-07-11 15:08:18
 * @Version: 3.0
 **/
@Repository
public interface ISignInDao {

    /**
     * 新增考勤签到
     *
     * @param params
     * @throws SaveException
     */
    void save(Map<String, Object> params) throws SaveException;

    /**
     * 删除考勤签到
     *
     * @param params
     * @throws RemoveException
     */
    void remove(Map<String, Object> params) throws RemoveException;

    /**
     * 删除考勤签到（物理）
     *
     * @param params
     * @throws RemoveException
     */
    void delete(Map<String, Object> params) throws RemoveException;

    /**
     * 修改考勤签到
     *
     * @param params
     * @throws UpdateException
     */
    void update(Map<String, Object> params) throws UpdateException;

    /**
     * 考勤签到详情
     *
     * @param params
     * @return
     * @throws SearchException
     */
    SignInDTO get(Map<String, Object> params) throws SearchException;

    /**
     * 考勤签到详情
     *
     * @param params
     * @return
     * @throws SearchException
     */
    SignInBO getBO(Map<String, Object> params) throws SearchException;

    /**
     * 考勤签到详情
     *
     * @param params
     * @return
     * @throws SearchException
     */
    SignInPO getPO(Map<String, Object> params) throws SearchException;

    /**
     * 考勤签到列表
     *
     * @param params
     * @return
     * @throws SearchException
     */
    List<SignInDTO> list(Map<String, Object> params) throws SearchException;

    /**
     * 考勤签到列表
     *
     * @param params
     * @return
     * @throws SearchException
     */
    List<SignInBO> listBO(Map<String, Object> params) throws SearchException;

    /**
     * 考勤签到列表
     *
     * @param params
     * @return
     * @throws SearchException
     */
    List<SignInPO> listPO(Map<String, Object> params) throws SearchException;

    /**
     * 考勤签到统计
     *
     * @param params
     * @return
     * @throws SearchException
     */
    Integer count(Map<String, Object> params) throws SearchException;

}