package ink.wgink.module.attn.service.attnconfig.impl;

import ink.wgink.common.base.DefaultBaseService;
import ink.wgink.module.attn.dao.attnconfig.IAttnConfigDao;
import ink.wgink.module.attn.pojo.dtos.attnconfig.AttnConfigDTO;
import ink.wgink.module.attn.pojo.vos.attnconfig.AttnConfigSaveVO;
import ink.wgink.module.attn.service.attnconfig.IAttnConfigService;
import ink.wgink.util.map.HashMapUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;

/**
 * @ClassName: AttnConfigServiceImpl
 * @Description: 考勤配置
 * @Author: CodeFactory
 * @Date: 2022-07-11 15:13:00
 * @Version: 3.0
 **/
@Service
public class AttnConfigServiceImpl extends DefaultBaseService implements IAttnConfigService {

    @Autowired
    private IAttnConfigDao attnConfigDao;

    @Override
    public void save(AttnConfigSaveVO attnConfigSaveVO) {
        // 清空
        attnConfigDao.delete();
        // 保存
        attnConfigSaveVO.getConfigs().forEach(attnConfigVO -> {
            Map<String, Object> params = HashMapUtil.beanToMap(attnConfigVO);
            attnConfigDao.save(params);
        });
    }

    @Override
    public AttnConfigDTO get(String attnConfigId) {
        return attnConfigDao.get(attnConfigId);
    }

    @Override
    public List<AttnConfigDTO> list() {
        return attnConfigDao.list();
    }


    @Override
    public Integer count(Map<String, Object> params) {
        Integer count = attnConfigDao.count(params);
        return count == null ? 0 : count;
    }

}